/* scopeman/dump.cc
 *
 * Copyright (C) 2017 Hajime Nanjo
 *
 * Application to decode a binary file 
 * generated with Tektornix oscilloscope,
 * using a waveform information file.
 * 
 * The license term of this code is GPLv2.
 * The author's email address is 
 * nanjo@champ.hep.sci.osaka-u.ac.jp 
 */

#include <fstream>
#include <iostream>
#include <cstdlib>


int main(int argc,char** argv)
{
  if(argc!=3) return 1;


  //wfin wfn
  

  char* wfin = argv[1];
  char* wfn = argv[2];
  

  
  
  int NumberOfBytes=0;
  double VerticalGain=0;
  double VerticalOffset=0;
  double HorizontalInterval=0;
  double HorizontalOffset=0;
  int NumberOfTraces=0;
  int NumberOfBytesPerDataPoint=0;
  int KeepAllDatapoints=0;

  int cnt=0;
  char lin[1024];
  std::ifstream wfi(wfin);
  while(1){
    wfi.getline(lin,1024);
    if(wfi.eof()) break;
    std::string slin=lin;
    std::string s0=std::string(slin,0,1);
    if(s0=="%" || slin.size()==0) continue;
    
    if(cnt==0) {
      NumberOfBytes=std::atoi(slin.c_str());
    } else if(cnt==1) {
      VerticalGain=std::atof(slin.c_str());
    } else if(cnt==2) {
      VerticalOffset=std::atof(slin.c_str());
    } else if(cnt==3) {
      HorizontalInterval=std::atof(slin.c_str());
    } else if(cnt==4) {
      HorizontalOffset=std::atof(slin.c_str());
    } else if(cnt==5) {
      NumberOfTraces=std::atoi(slin.c_str());
    } else if(cnt==6) {
      NumberOfBytesPerDataPoint=std::atoi(slin.c_str());
    } else if(cnt==7) {
      KeepAllDatapoints=std::atoi(slin.c_str());
    }
    cnt++;
  }
  
  //  std::cout << VerticalGain << "\t"
  //      	    << VerticalOffset << "\t"
  //      	    << HorizontalInterval << "\t"
  //      	    << HorizontalOffset << std::endl;
  //  return 0;

  
  
  double* xa = new double[5000];
  double* ya = new double[5000];

  char wfname[1024];
  
  int   lc=0;
  short val=0;
  std::ifstream fi(wfn, std::ios::binary);
  //if(!fi.is_open()) continue;
      
  while(fi.read ((char *)&val,sizeof(short))) {
    double x=(lc*HorizontalInterval+HorizontalOffset);
    double y=(val*VerticalGain-VerticalOffset);
    //double x=lc;
    //double y=val;
    std::cout << x << "\t" << y << std::endl;
    lc++;
  }

  return 0;
}
