/* scoepman/tek_scope.h
 *
 * Copyright (C) for the modification 2017 Hajime Nanjo
 *
 * The file, tek_user.h, with the revision 1.6 from tek_1.04.tar.gz 
 * provided by S. D.Sharples was modified on 2017/06/16.
 * This program was licensed under the term of the GPLv2 license.
 * Original revision history was included elsewhere.
 * The modification was made for the update of vxi11 library,
 * where the function interfaces were changed.
 * Only some part of the original functions were included with the modification.
 * The author's email address is 
 * nanjo@champ.hep.sci.osaka-u.ac.jp
 *
 * 
 * tek_user.h
 * Copyright (C) 2006-2007 Steve D. Sharples
 *
 * User library of useful functions for talking to Tektronix instruments
 * (e.g. scopes and AFG's) using the VXI11 protocol, for Linux. You will also
 * need the vxi11.tar.gz source, currently available from:
 * http://optics.eee.nottingham.ac.uk/vxi11/
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation;  version 2
 * of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * The author's email address is steve.sharples@nottingham.ac.uk
 */

#ifndef tek_scope_h
#define tek_scope_h

#include "../vxi11/vxi11_user.h"

int  vxi11_send(VXI11_CLINK *clink, const char *cmd);
int  tek_scope_is_TDS3000(VXI11_CLINK *clink);
int  tek_scope_init(VXI11_CLINK *clink);
void tek_scope_force_xincr_update(VXI11_CLINK *clink, unsigned long timeout);
long tek_scope_set_for_capture(VXI11_CLINK *clink, int clear_sweeps, unsigned long timeout);
long tek_scope_write_wfi_file(VXI11_CLINK *clink, char *wfiname, char *captured_by, 
			      int no_of_traces, unsigned long timeout);
long tek_scope_write_wfi_file(VXI11_CLINK *clink, char *wfiname, char *source, char *captured_by, 
			      int no_of_traces, unsigned long timeout);
long tek_scope_calculate_no_of_bytes(VXI11_CLINK *clink, int is_TDS3000, unsigned long timeout);

void tek_scope_channel_str(char chan, char *source);
void tek_scope_channel_str(char *source); 

#endif
